INOTIFY_ADD_WATCH(2)

NAME
inotify_add_watch - add a watch to an initialized inotify instance

SYNOPSIS
#include <inotify.h>

int inotify_add_watch(int fd, const char *path, uint32_t mask);

DESCRIPTION
inotify_add_watch() adds a watch on the file at pathname path to the inotify instance mapped by the file descriptor fd with the event mask given by the bitmask mask. See inotify(7) for a description of the bits that can be set in mask. A successful call to inotify_add_watch() returns the unique watch descriptor associated with path for this inotify instance. If path was not previously being watched by this inotify instance, then the watch descriptor is newly allocated. If path was already being watched, then the descriptor for the existing watch is returned. The watch descriptor is returned by later read(2)s from the inotify file descriptor. These reads fetch inotify_event structures indicating file system events; the returned watch descriptor identifies the object for which the event occurred.

RETURN VALUE
On success, inotify_add_watch() returns a non-negative watch descriptor. On error -1 is returned and errno is set appropriately.

ERRORS

EACCESS
    Read access to the given file is not permitted.

EBADF
    The given file descriptor is not valid.

EFAULT
    path points outside of the process's accessible address space.

EINVAL
    The given event mask contains no legal events.

ENOMEM
    Insufficient kernel memory was available.

ENOSPC
    The user limit on the total number of inotify watches was reached or the kernel failed to allocate a needed resource.

HISTORY
Inotify was merged into the 2.6.13 Linux kernel.

CONFORMING TO
This system call is Linux specific.

BUGS
In kernels before 2.6.16, the IN_ONESHOT mask flag does not work.

SEE ALSO
inotify_init(2), inotify_rm_watch(2), inotify(7).